package resolver

// This file will be automatically regenerated based on the schema, any resolver implementations
// will be copied through when generating and any unknown code will be moved to the end.
// Code generated by github.com/99designs/gqlgen version v0.17.40

import (
	"context"
	"fmt"

	_map "gitlab.com/talgat.s/belka-go/graph/map"
	"gitlab.com/talgat.s/belka-go/graph/model"
	"gitlab.com/talgat.s/belka-go/internal/auth"
)

// Login is the resolver for the login field.
func (r *mutationResolver) Login(ctx context.Context, email string, password string) (*model.UserWithToken, error) {
	r.Log.InfoContext(ctx, "start mutation Login", "email", email)

	user, err := r.DB.Login(ctx, email, password)
	if err != nil {
		r.Log.ErrorContext(ctx, "fail mutation Login", "error", err, "email", email)
		return nil, err
	}

	pair, err := auth.GenerateTokenPair(
		r.Conf.TokenKey,
		r.Conf.AccessTokenExp,
		&auth.User{
			ID:    user.ID,
			Email: user.Email,
			Role:  user.Role,
		},
	)
	if err != nil {
		r.Log.ErrorContext(
			ctx,
			"fail mutation Login",
			"error", fmt.Errorf("failed to sign token: %w", err),
			"email", email,
		)
		return nil, err
	}

	if err = r.DB.SaveToken(ctx, user.ID, pair.RefreshToken); err != nil {
		r.Log.ErrorContext(
			ctx,
			"fail mutation Login",
			"error", fmt.Errorf("failed to save token into db: %w", err),
			"email", email,
		)
		return nil, err
	}

	r.Log.InfoContext(ctx, "success mutation Login")

	return &model.UserWithToken{
		User: &model.User{
			ID:    user.ID,
			Email: user.Email,
			Role:  _map.RoleToGQLRole(user.Role),
		},
		Tokens: &model.Tokens{
			Access:  pair.AccessToken,
			Refresh: pair.RefreshToken,
		},
	}, nil
}

// Register is the resolver for the register field.
func (r *mutationResolver) Register(ctx context.Context, email string, password string) (*model.User, error) {
	r.Log.InfoContext(ctx, "start mutation Register", "email", email)

	user, err := r.DB.Register(ctx, email, password)
	if err != nil {
		r.Log.ErrorContext(ctx, "fail mutation Register", "error", err, "email", email)
		return nil, err
	}

	r.Log.InfoContext(ctx, "success mutation Register")

	return &model.User{
		ID:    user.ID,
		Email: user.Email,
		Role:  _map.RoleToGQLRole(user.Role),
	}, nil
}

// RefreshToken is the resolver for the refreshToken field.
func (r *mutationResolver) RefreshToken(ctx context.Context, refreshToken string) (*model.Tokens, error) {
	r.Log.InfoContext(ctx, "start mutation RefreshToken")

	u, err := auth.ParseRefreshToken(r.Conf.TokenKey, refreshToken)
	if err != nil {
		r.Log.InfoContext(
			ctx,
			"fail mutation RefreshToken",
			"error", fmt.Errorf("failed to parse refresh token: %w", err),
		)
		return nil, err
	}

	if err = r.DB.ValidateToken(ctx, u.ID, refreshToken); err != nil {
		r.Log.ErrorContext(
			ctx,
			"fail mutation RefreshToken",
			"error", fmt.Errorf("failed to validate token: %w", err),
			"id", u.ID,
		)
		return nil, err
	}

	user, err := r.DB.GetUserByID(ctx, u.ID)
	if err != nil {
		r.Log.InfoContext(
			ctx,
			"fail mutation RefreshToken",
			"error", fmt.Errorf("failed to get user from db: %w", err),
		)
		return nil, err
	}

	pair, err := auth.GenerateTokenPair(
		r.Conf.TokenKey,
		r.Conf.AccessTokenExp,
		&auth.User{
			ID:    user.ID,
			Email: user.Email,
			Role:  user.Role,
		},
	)
	if err != nil {
		r.Log.ErrorContext(
			ctx,
			"fail mutation RefreshToken",
			"error", fmt.Errorf("failed to sign token: %w", err),
		)
		return nil, err
	}

	if err = r.DB.SaveToken(ctx, user.ID, pair.RefreshToken); err != nil {
		r.Log.ErrorContext(
			ctx,
			"fail mutation RefreshToken",
			"error", fmt.Errorf("failed to save token into db: %w", err),
		)
		return nil, err
	}

	r.Log.InfoContext(ctx, "success mutation RefreshToken")

	return &model.Tokens{
		Access:  pair.AccessToken,
		Refresh: pair.RefreshToken,
	}, nil
}
